#include <linux/string.h>
#include <linux/tty.h>
#include <linux/mm.h>
#include <asm/pgtable.h>
//#define PAGE_OFFSET_RAW	0x70000000
#define PAGE_OFFSET_RAW	__PAGE_OFFSET
#include <asm/lotol.h>
#include <asm/lotol_fdesc.h>

#define CL_BASE_ADDR    ((char *) PAGE_OFFSET_RAW + 0x90000)
#define CL_OFFSET       ((unsigned short *) (PAGE_OFFSET_RAW + 0x90022))
#define COMMAND_LINE_SIZE 256
#define PARAM   ((unsigned char *)empty_zero_page)
#define SCREEN_INFO ((struct screen_info *) (PARAM+0))


static void setup_video_card(int mode)
{
	struct screen_info *info = SCREEN_INFO;
	
	/*
	 * missing: send init packet to frontend/gfx.c
	 */

	info->orig_video_isVGA = VIDEO_TYPE_VLFB;
	info->lfb_base = PA_VIDEO_MEMORY_HIGH;
	
	switch(mode) {
	case 769:
		info->lfb_width      = 640;
		info->lfb_height     = 480;
		info->lfb_depth      = 8;
		info->lfb_size       = 5;
		info->lfb_linelength = 640;
		info->pages          = 0;
		break;
	case 771:
		info->lfb_width      = 800;
		info->lfb_height     = 600;
		info->lfb_depth      = 8;
		info->lfb_size       = 8;
		info->lfb_linelength = 800;
		info->pages          = 0;
		break;
	case 773:
                info->lfb_width      = 1024;
		info->lfb_height     = 768;
		info->lfb_depth      = 8;				    
		info->lfb_size       = 12;
		info->lfb_linelength = 1024;
		info->pages          = 0;
		break;
	case 775:
		info->lfb_width      = 1280;
                info->lfb_height     = 1024;
		info->lfb_depth      = 8;
		info->lfb_size       = 21;
		info->lfb_linelength = 1280;
		info->pages          = 0;
		break;
	case 786:
		info->lfb_width	     = 640;
		info->lfb_height     = 480;
		info->lfb_depth      = 24;
		info->lfb_size       = 19;
		info->lfb_linelength = 2560;
		info->pages          = 0;
		break;
	}
}

/*
 * thanks modedb.c
 */
static int __atoi(char *string)
{
	int val = 0;

	for(;; string++) {
		switch(*string) {
		case '0' ... '9':
			val = 10 * val + (*string - '0');
			break;
		default:
			return val;
		}
	}
}

void init_video(void)
{
	char cmd_line[COMMAND_LINE_SIZE];
        char *next;

        memcpy(cmd_line, (char *) CL_BASE_ADDR + *CL_OFFSET, COMMAND_LINE_SIZE);
        next = cmd_line;

        for(;;) {
                if(!(next = strchr(next, 'v')) || !next) {
                        break;
                }
                if(!strncmp(next, "vga=", 4)) {
			setup_video_card(__atoi(next+4));
                        break;
                }
                else next++;
        }
} 
